
set echo on

DROP TABLE e1;
DROP TABLE e2;

CREATE TABLE e1 (empno PRIMARY KEY, ename, deptno, job) 
AS
   SELECT ROWNUM, ename, deptno, job
   FROM   emp
   ,      all_objects
   WHERE  deptno IN (10,20);

CREATE TABLE e2 (empno PRIMARY KEY, ename, deptno, job) 
AS
   SELECT ROWNUM, ename, deptno, job
   FROM   emp
   ,      all_objects
   WHERE  deptno IN (20,30,40);

exec DBMS_STATS.GATHER_TABLE_STATS(user,'e1');
exec DBMS_STATS.GATHER_TABLE_STATS(user,'e2');

SELECT COUNT(*) FROM e1;
SELECT COUNT(*) FROM e2;

set timing on
set autotrace traceonly statistics

SELECT e1.ename, e1.deptno, e1.job
,      e2.ename, e2.deptno, e2.job
FROM   e1
       FULL OUTER JOIN
       e2
USING (empno);

ALTER TABLE e1 DROP PRIMARY KEY;
ALTER TABLE e2 DROP PRIMARY KEY;

SELECT e1.ename, e1.deptno, e1.job
,      e2.ename, e2.deptno, e2.job
FROM   e1
       FULL OUTER JOIN
       e2
USING (empno);

set autotrace off

