
set echo on

DROP TABLE e1;
DROP TABLE e2;
DROP TABLE e3;

CREATE TABLE e1 (empno, ename, deptno, job) 
AS
   SELECT ROWNUM, ename, deptno, job
   FROM   emp
   ,      all_objects
   WHERE  deptno = 10
   AND    ROWNUM <= 20000;

CREATE TABLE e2 (empno, ename, deptno, job) 
AS
   SELECT ROWNUM, ename, deptno, job
   FROM   emp
   ,      all_objects
   WHERE  deptno IN (20)
   AND    ROWNUM <= 30000;

CREATE TABLE e3 (empno, ename, deptno, job) 
AS
   SELECT ROWNUM, ename, deptno, job
   FROM   emp
   ,      all_objects
   WHERE  deptno IN (30)
   AND    ROWNUM <= 40000;

exec DBMS_STATS.GATHER_TABLE_STATS(user,'e1');
exec DBMS_STATS.GATHER_TABLE_STATS(user,'e2');
exec DBMS_STATS.GATHER_TABLE_STATS(user,'e3');

set timing on

SELECT COUNT(e1.ename), COUNT(e2.ename), COUNT(e3.ename)
FROM   e1
       FULL OUTER JOIN
       e2
       USING (empno)
       FULL OUTER JOIN
       e3
       USING (empno);


